package hu.uniobuda.nik.jsonlistview;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import org.json.JSONArray;
import org.json.JSONException;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

public class JsonListViewActivity extends Activity {

	private Button addButton;
	private ListView listView;
	private SajatAdapter adapter;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		// sszektjk a Json Adapternket a listview-al
		adapter = new SajatAdapter("http://nik.uni-obuda.hu/malk/android/segedlet/pest_megye.txt");
		listView = (ListView) findViewById(R.id.listView);
		listView.setAdapter(adapter);
		
		addButton = (Button)findViewById(R.id.add);
		addButton.setOnClickListener(new OnClickListener() {			
			public void onClick(View v) {
				adapter.addItem(54324, "Senki fldje");
			}
		});

	}

	public class SajatAdapter extends BaseAdapter {

		// Itt lesznek a lista elemek
		private JSONArray items = new JSONArray();

		public SajatAdapter(String uri) {
			try {
				// Letlts --------
				URL url = new URL(uri);
				URLConnection conn = url.openConnection();
				InputStream is = conn.getInputStream();				
				BufferedReader br = new BufferedReader( new InputStreamReader(is));
				String line;
				StringBuilder sb = new StringBuilder();
				while ((line = br.readLine()) != null)
					sb.append(line);
				br.close();
				is.close();

				// Parse -----------
				this.items = new JSONArray(sb.toString());
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (JSONException e) {
				e.printStackTrace();
			}
		}

		public void addItem(int count, String city){
			JSONArray arr = new JSONArray();
					  arr.put(city);
					  arr.put(count);					  
			items.put(arr);
			notifyDataSetChanged();		// rtestennk kell, hogy vltozs trtnt
		}
		
		// Innen fogja tudni, hogy mennyi eleme van a listnknak
		public int getCount() {
			return items.length();
		}
		
		// I-dik elem tadsa
		public Object getItem(int arg0) {
			try {
				return items.get(arg0);
			} catch (JSONException e) {
				return null;
			}
		}

		// Egy egyedi azonost tadsa
		public long getItemId(int arg0) {
			return arg0;
		}

		// A lnyeg: egy lista elem felletnek tadsa
		// Erforrs ignyes, ezrt jrahasznljuk a rgebbu View-kat
		// gy 2000 elem esetn is ~5-30 view pldnyt tartunk a memriban
		public View getView(int position, View convertView, ViewGroup parent) {
			
			// Ha nem kapunk convertView-t (pl. els kirajzolskor), azaz korbbi elemet, akkor be kell tltennk egy j pldnyt
			// Ez csak 1-es szint gyorsts, van mg egy gyorstsi lehetsg
			if(convertView == null)
				convertView = View .inflate(parent.getContext(), R.layout.list_item, null);

			// Megkeressk a TextView-kat s belltjuk az adatokat
			try {
				JSONArray itemArray = items.getJSONArray(position);
				TextView count = (TextView) convertView.findViewById(R.id.count);
				count.setText(itemArray.getString(0));
				TextView city = (TextView) convertView.findViewById(R.id.city);
				city.setText(itemArray.getString(1));
			} catch (JSONException e) {
				e.printStackTrace();
			}

			return convertView;
		}

	}

}